from enum import Enum


class HealthDataTypeAndroid(Enum):
    ACTIVE_ENERGY_BURNED = 'ACTIVE_ENERGY_BURNED'
    BLOOD_GLUCOSE = 'BLOOD_GLUCOSE'
    BLOOD_OXYGEN = 'BLOOD_OXYGEN'
    BLOOD_PRESSURE_DIASTOLIC = 'BLOOD_PRESSURE_DIASTOLIC'
    BLOOD_PRESSURE_SYSTOLIC = 'BLOOD_PRESSURE_SYSTOLIC'
    BODY_FAT_PERCENTAGE = 'BODY_FAT_PERCENTAGE'
    LEAN_BODY_MASS = 'LEAN_BODY_MASS'
    BODY_MASS_INDEX = 'BODY_MASS_INDEX'
    BODY_TEMPERATURE = 'BODY_TEMPERATURE'
    BODY_WATER_MASS = 'BODY_WATER_MASS'
    HEART_RATE = 'HEART_RATE'
    HEART_RATE_VARIABILITY_RMSSD = 'HEART_RATE_VARIABILITY_RMSSD'
    HEIGHT = 'HEIGHT'
    STEPS = 'STEPS'
    WEIGHT = 'WEIGHT'
    DISTANCE_DELTA = 'DISTANCE_DELTA'
    SLEEP_ASLEEP = 'SLEEP_ASLEEP'
    SLEEP_AWAKE_IN_BED = 'SLEEP_AWAKE_IN_BED'
    SLEEP_AWAKE = 'SLEEP_AWAKE'
    SLEEP_DEEP = 'SLEEP_DEEP'
    SLEEP_LIGHT = 'SLEEP_LIGHT'
    SLEEP_OUT_OF_BED = 'SLEEP_OUT_OF_BED'
    SLEEP_REM = 'SLEEP_REM'
    SLEEP_SESSION = 'SLEEP_SESSION'
    SLEEP_UNKNOWN = 'SLEEP_UNKNOWN'
    WATER = 'WATER'
    WORKOUT = 'WORKOUT'
    RESTING_HEART_RATE = 'RESTING_HEART_RATE'
    FLIGHTS_CLIMBED = 'FLIGHTS_CLIMBED'
    BASAL_ENERGY_BURNED = 'BASAL_ENERGY_BURNED'
    RESPIRATORY_RATE = 'RESPIRATORY_RATE'
    NUTRITION = 'NUTRITION'
    TOTAL_CALORIES_BURNED = 'TOTAL_CALORIES_BURNED'
    MENSTRUATION_FLOW = 'MENSTRUATION_FLOW'


class HealthDataTypeIOS(Enum):
    ACTIVE_ENERGY_BURNED = 'ACTIVE_ENERGY_BURNED'
    ATRIAL_FIBRILLATION_BURDEN = 'ATRIAL_FIBRILLATION_BURDEN'
    AUDIOGRAM = 'AUDIOGRAM'
    BASAL_ENERGY_BURNED = 'BASAL_ENERGY_BURNED'
    BLOOD_GLUCOSE = 'BLOOD_GLUCOSE'
    BLOOD_OXYGEN = 'BLOOD_OXYGEN'
    BLOOD_PRESSURE_DIASTOLIC = 'BLOOD_PRESSURE_DIASTOLIC'
    BLOOD_PRESSURE_SYSTOLIC = 'BLOOD_PRESSURE_SYSTOLIC'
    BODY_FAT_PERCENTAGE = 'BODY_FAT_PERCENTAGE'
    LEAN_BODY_MASS = 'LEAN_BODY_MASS'
    BODY_MASS_INDEX = 'BODY_MASS_INDEX'
    BODY_TEMPERATURE = 'BODY_TEMPERATURE'
    DIETARY_CARBS_CONSUMED = 'DIETARY_CARBS_CONSUMED'
    DIETARY_CAFFEINE = 'DIETARY_CAFFEINE'
    DIETARY_ENERGY_CONSUMED = 'DIETARY_ENERGY_CONSUMED'
    DIETARY_FATS_CONSUMED = 'DIETARY_FATS_CONSUMED'
    DIETARY_PROTEIN_CONSUMED = 'DIETARY_PROTEIN_CONSUMED'
    DIETARY_FIBER = 'DIETARY_FIBER'
    DIETARY_SUGAR = 'DIETARY_SUGAR'
    DIETARY_FAT_MONOUNSATURATED = 'DIETARY_FAT_MONOUNSATURATED'
    DIETARY_FAT_POLYUNSATURATED = 'DIETARY_FAT_POLYUNSATURATED'
    DIETARY_FAT_SATURATED = 'DIETARY_FAT_SATURATED'
    DIETARY_CHOLESTEROL = 'DIETARY_CHOLESTEROL'
    DIETARY_VITAMIN_A = 'DIETARY_VITAMIN_A'
    DIETARY_THIAMIN = 'DIETARY_THIAMIN'
    DIETARY_RIBOFLAVIN = 'DIETARY_RIBOFLAVIN'
    DIETARY_NIACIN = 'DIETARY_NIACIN'
    DIETARY_PANTOTHENIC_ACID = 'DIETARY_PANTOTHENIC_ACID'
    DIETARY_VITAMIN_B6 = 'DIETARY_VITAMIN_B6'
    DIETARY_BIOTIN = 'DIETARY_BIOTIN'
    DIETARY_VITAMIN_B12 = 'DIETARY_VITAMIN_B12'
    DIETARY_VITAMIN_C = 'DIETARY_VITAMIN_C'
    DIETARY_VITAMIN_D = 'DIETARY_VITAMIN_D'
    DIETARY_VITAMIN_E = 'DIETARY_VITAMIN_E'
    DIETARY_VITAMIN_K = 'DIETARY_VITAMIN_K'
    DIETARY_FOLATE = 'DIETARY_FOLATE'
    DIETARY_CALCIUM = 'DIETARY_CALCIUM'
    DIETARY_CHLORIDE = 'DIETARY_CHLORIDE'
    DIETARY_IRON = 'DIETARY_IRON'
    DIETARY_MAGNESIUM = 'DIETARY_MAGNESIUM'
    DIETARY_PHOSPHORUS = 'DIETARY_PHOSPHORUS'
    DIETARY_POTASSIUM = 'DIETARY_POTASSIUM'
    DIETARY_SODIUM = 'DIETARY_SODIUM'
    DIETARY_ZINC = 'DIETARY_ZINC'
    DIETARY_CHROMIUM = 'DIETARY_CHROMIUM'
    DIETARY_COPPER = 'DIETARY_COPPER'
    DIETARY_IODINE = 'DIETARY_IODINE'
    DIETARY_MANGANESE = 'DIETARY_MANGANESE'
    DIETARY_MOLYBDENUM = 'DIETARY_MOLYBDENUM'
    DIETARY_SELENIUM = 'DIETARY_SELENIUM'
    ELECTRODERMAL_ACTIVITY = 'ELECTRODERMAL_ACTIVITY'
    FORCED_EXPIRATORY_VOLUME = 'FORCED_EXPIRATORY_VOLUME'
    HEART_RATE = 'HEART_RATE'
    HEART_RATE_VARIABILITY_SDNN = 'HEART_RATE_VARIABILITY_SDNN'
    HEIGHT = 'HEIGHT'
    INSULIN_DELIVERY = 'INSULIN_DELIVERY'
    HIGH_HEART_RATE_EVENT = 'HIGH_HEART_RATE_EVENT'
    IRREGULAR_HEART_RATE_EVENT = 'IRREGULAR_HEART_RATE_EVENT'
    LOW_HEART_RATE_EVENT = 'LOW_HEART_RATE_EVENT'
    RESTING_HEART_RATE = 'RESTING_HEART_RATE'
    RESPIRATORY_RATE = 'RESPIRATORY_RATE'
    PERIPHERAL_PERFUSION_INDEX = 'PERIPHERAL_PERFUSION_INDEX'
    STEPS = 'STEPS'
    WAIST_CIRCUMFERENCE = 'WAIST_CIRCUMFERENCE'
    WALKING_HEART_RATE = 'WALKING_HEART_RATE'
    WEIGHT = 'WEIGHT'
    FLIGHTS_CLIMBED = 'FLIGHTS_CLIMBED'
    DISTANCE_WALKING_RUNNING = 'DISTANCE_WALKING_RUNNING'
    DISTANCE_SWIMMING = 'DISTANCE_SWIMMING'
    DISTANCE_CYCLING = 'DISTANCE_CYCLING'
    MINDFULNESS = 'MINDFULNESS'
    SLEEP_ASLEEP = 'SLEEP_ASLEEP'
    SLEEP_AWAKE = 'SLEEP_AWAKE'
    SLEEP_DEEP = 'SLEEP_DEEP'
    SLEEP_IN_BED = 'SLEEP_IN_BED'
    SLEEP_LIGHT = 'SLEEP_LIGHT'
    SLEEP_REM = 'SLEEP_REM'
    WATER = 'WATER'
    EXERCISE_TIME = 'EXERCISE_TIME'
    WORKOUT = 'WORKOUT'
    HEADACHE_NOT_PRESENT = 'HEADACHE_NOT_PRESENT'
    HEADACHE_MILD = 'HEADACHE_MILD'
    HEADACHE_MODERATE = 'HEADACHE_MODERATE'
    HEADACHE_SEVERE = 'HEADACHE_SEVERE'
    HEADACHE_UNSPECIFIED = 'HEADACHE_UNSPECIFIED'
    ELECTROCARDIOGRAM = 'ELECTROCARDIOGRAM'
    NUTRITION = 'NUTRITION'
    GENDER = 'GENDER'
    BIRTH_DATE = 'BIRTH_DATE'
    BLOOD_TYPE = 'BLOOD_TYPE'
    MENSTRUATION_FLOW = 'MENSTRUATION_FLOW'
    WATER_TEMPERATURE = 'WATER_TEMPERATURE'
    UNDERWATER_DEPTH = 'UNDERWATER_DEPTH'
    UV_INDEX = 'UV_INDEX'
    TOTAL_CALORIES_BURNED = 'TOTAL_CALORIES_BURNED'


class HealthWorkoutActivityType(Enum):
    # --- Both ---
    AMERICAN_FOOTBALL = 'AMERICAN_FOOTBALL'
    ARCHERY = 'ARCHERY'
    AUSTRALIAN_FOOTBALL = 'AUSTRALIAN_FOOTBALL'
    BADMINTON = 'BADMINTON'
    BASEBALL = 'BASEBALL'
    BASKETBALL = 'BASKETBALL'
    BIKING = 'BIKING'   # This also entails the iOS version where it is called CYCLING
    BOXING = 'BOXING'
    CRICKET = 'CRICKET'
    CROSS_COUNTRY_SKIING = 'CROSS_COUNTRY_SKIING'
    CURLING = 'CURLING'
    DOWNHILL_SKIING = 'DOWNHILL_SKIING'
    ELLIPTICAL = 'ELLIPTICAL'
    FENCING = 'FENCING'
    GOLF = 'GOLF'
    GYMNASTICS = 'GYMNASTICS'
    HANDBALL = 'HANDBALL'
    HIGH_INTENSITY_INTERVAL_TRAINING = 'HIGH_INTENSITY_INTERVAL_TRAINING'
    HIKING = 'HIKING'
    HOCKEY = 'HOCKEY'
    JUMP_ROPE = 'JUMP_ROPE'
    KICKBOXING = 'KICKBOXING'
    MARTIAL_ARTS = 'MARTIAL_ARTS'
    PILATES = 'PILATES'
    RACQUETBALL = 'RACQUETBALL'
    ROWING = 'ROWING'
    RUGBY = 'RUGBY'
    RUNNING = 'RUNNING'
    SAILING = 'SAILING'
    SKATING = 'SKATING'
    SNOWBOARDING = 'SNOWBOARDING'
    SOCCER = 'SOCCER'
    SOFTBALL = 'SOFTBALL'
    SQUASH = 'SQUASH'
    STAIR_CLIMBING = 'STAIR_CLIMBING'
    SWIMMING = 'SWIMMING'
    TABLE_TENNIS = 'TABLE_TENNIS'
    TENNIS = 'TENNIS'
    VOLLEYBALL = 'VOLLEYBALL'
    WALKING = 'WALKING'
    WATER_POLO = 'WATER_POLO'
    YOGA = 'YOGA'

    # --- iOS only ---
    BARRE = 'BARRE'
    BOWLING = 'BOWLING'
    CARDIO_DANCE = 'CARDIO_DANCE'
    CLIMBING = 'CLIMBING'
    COOLDOWN = 'COOLDOWN'
    CORE_TRAINING = 'CORE_TRAINING'
    CROSS_TRAINING = 'CROSS_TRAINING'
    DISC_SPORTS = 'DISC_SPORTS'
    EQUESTRIAN_SPORTS = 'EQUESTRIAN_SPORTS'
    FISHING = 'FISHING'
    FITNESS_GAMING = 'FITNESS_GAMING'
    FLEXIBILITY = 'FLEXIBILITY'
    FUNCTIONAL_STRENGTH_TRAINING = 'FUNCTIONAL_STRENGTH_TRAINING'
    HAND_CYCLING = 'HAND_CYCLING'
    HUNTING = 'HUNTING'
    LACROSSE = 'LACROSSE'
    MIND_AND_BODY = 'MIND_AND_BODY'
    MIXED_CARDIO = 'MIXED_CARDIO'
    PADDLE_SPORTS = 'PADDLE_SPORTS'
    PICKLEBALL = 'PICKLEBALL'
    PLAY = 'PLAY'
    PREPARATION_AND_RECOVERY = 'PREPARATION_AND_RECOVERY'
    SNOW_SPORTS = 'SNOW_SPORTS'
    SOCIAL_DANCE = 'SOCIAL_DANCE'
    STAIRS = 'STAIRS'
    STEP_TRAINING = 'STEP_TRAINING'
    SURFING = 'SURFING'
    TAI_CHI = 'TAI_CHI'
    TRACK_AND_FIELD = 'TRACK_AND_FIELD'
    TRADITIONAL_STRENGTH_TRAINING = 'TRADITIONAL_STRENGTH_TRAINING'
    WATER_FITNESS = 'WATER_FITNESS'
    WATER_SPORTS = 'WATER_SPORTS'
    WHEELCHAIR_RUN_PACE = 'WHEELCHAIR_RUN_PACE'
    WHEELCHAIR_WALK_PACE = 'WHEELCHAIR_WALK_PACE'
    WRESTLING = 'WRESTLING'
    UNDERWATER_DIVING = 'UNDERWATER_DIVING'

    # --- Android only ---
    BIKING_STATIONARY = 'BIKING_STATIONARY'
    CALISTHENICS = 'CALISTHENICS'
    DANCING = 'DANCING'
    FRISBEE_DISC = 'FRISBEE_DISC'
    GUIDED_BREATHING = 'GUIDED_BREATHING'
    ICE_SKATING = 'ICE_SKATING'
    PARAGLIDING = 'PARAGLIDING'
    ROCK_CLIMBING = 'ROCK_CLIMBING' # on iOS this is the same as CLIMBING
    ROWING_MACHINE = 'ROWING_MACHINE'
    RUNNING_TREADMILL = 'RUNNING_TREADMILL' # on iOS this is the same as RUNNING
    SCUBA_DIVING = 'SCUBA_DIVING'
    SKIING = 'SKIING'
    SNOWSHOEING = 'SNOWSHOEING'
    STAIR_CLIMBING_MACHINE = 'STAIR_CLIMBING_MACHINE'
    STRENGTH_TRAINING = 'STRENGTH_TRAINING'
    SWIMMING_OPEN_WATER = 'SWIMMING_OPEN_WATER'
    SWIMMING_POOL = 'SWIMMING_POOL'
    WALKING_TREADMILL = 'WALKING_TREADMILL'
    WEIGHTLIFTING = 'WEIGHTLIFTING'
    WHEELCHAIR = 'WHEELCHAIR'

    # ------
    OTHER = 'OTHER'


class HealthDataUnit(Enum):
    # Mass units
    GRAM = 'GRAM'
    KILOGRAM = 'KILOGRAM'
    OUNCE = 'OUNCE'
    POUND = 'POUND'
    STONE = 'STONE'

    # Length units
    METER = 'METER'
    INCH = 'INCH'
    FOOT = 'FOOT'
    YARD = 'YARD'
    MILE = 'MILE'

    # Volume units
    LITER = 'LITER'
    MILLILITER = 'MILLILITER'
    FLUID_OUNCE_US = 'FLUID_OUNCE_US'
    FLUID_OUNCE_IMPERIAL = 'FLUID_OUNCE_IMPERIAL'
    CUP_US = 'CUP_US'
    CUP_IMPERIAL = 'CUP_IMPERIAL'
    PINT_US = 'PINT_US'
    PINT_IMPERIAL = 'PINT_IMPERIAL'

    # Pressure units
    PASCAL = 'PASCAL'
    MILLIMETER_OF_MERCURY = 'MILLIMETER_OF_MERCURY'
    INCHES_OF_MERCURY = 'INCHES_OF_MERCURY'
    CENTIMETER_OF_WATER = 'CENTIMETER_OF_WATER'
    ATMOSPHERE = 'ATMOSPHERE'
    DECIBEL_A_WEIGHTED_SOUND_PRESSURE_LEVEL = 'DECIBEL_A_WEIGHTED_SOUND_PRESSURE_LEVEL'

    # Time units
    SECOND = 'SECOND'
    MILLISECOND = 'MILLISECOND'
    MINUTE = 'MINUTE'
    HOUR = 'HOUR'
    DAY = 'DAY'

    # Energy units
    JOULE = 'JOULE'
    KILOCALORIE = 'KILOCALORIE'
    LARGE_CALORIE = 'LARGE_CALORIE'
    SMALL_CALORIE = 'SMALL_CALORIE'

    # Temperature units
    DEGREE_CELSIUS = 'DEGREE_CELSIUS'
    DEGREE_FAHRENHEIT = 'DEGREE_FAHRENHEIT'
    KELVIN = 'KELVIN'

    # Hearing units
    DECIBEL_HEARING_LEVEL = 'DECIBEL_HEARING_LEVEL'

    # Frequency units
    HERTZ = 'HERTZ'

    # Electrical conductance units
    SIEMEN = 'SIEMEN'

    # Potential units
    VOLT = 'VOLT'

    # Pharmacology units
    INTERNATIONAL_UNIT = 'INTERNATIONAL_UNIT'

    # Scalar units
    COUNT = 'COUNT'
    PERCENT = 'PERCENT'

    # Other units
    BEATS_PER_MINUTE = 'BEATS_PER_MINUTE'
    RESPIRATIONS_PER_MINUTE = 'RESPIRATIONS_PER_MINUTE'
    MILLIGRAM_PER_DECILITER = 'MILLIGRAM_PER_DECILITER'
    UNKNOWN_UNIT = 'UNKNOWN_UNIT'
    NO_UNIT = 'NO_UNIT'


class RecordingMethod(Enum):
    UNKNOWN = 'unknown'
    ACTIVE = 'active'
    AUTOMATIC = 'automatic'
    MANUAL = 'manual'


class MealType(Enum):
    BREAKFAST = 'BREAKFAST'
    LUNCH = 'LUNCH'
    DINNER = 'DINNER'
    SNACK = 'SNACK'
    UNKNOWN = 'UNKNOWN'


class MenstrualFlow(Enum):
    UNSPECIFIED = 'unspecified'
    NONE = 'none'
    LIGHT = 'light'
    MEDIUM = 'medium'
    HEAVY = 'heavy'
    SPOTTING = 'spotting'


class InsulinDeliveryReason(Enum):
    NOT_SET = 'NOT_SET'
    BASAL = 'BASAL'
    BOLUS = 'BOLUS'


class DataAccess(Enum):
    READ = 'READ'
    WRITE = 'WRITE',
    READ_WRITE = 'READ_WRITE'


class HealthConnectSdkStatus(Enum):
    SDK_UNAVAILABLE = 1
    SDK_UNAVAILABLE_PROVIDER_UPDATE_REQUIRED = 2
    SDK_AVAILABLE = 3

    @classmethod
    def from_string(cls, dart_enum_str: str) -> "HealthConnectSdkStatus":
        mapping = {
            "HealthConnectSdkStatus.sdkUnavailable": cls.SDK_UNAVAILABLE,
            "HealthConnectSdkStatus.sdkUnavailableProviderUpdateRequired": cls.SDK_UNAVAILABLE_PROVIDER_UPDATE_REQUIRED,
            "HealthConnectSdkStatus.sdkAvailable": cls.SDK_AVAILABLE,
        }
        return mapping.get(dart_enum_str, cls.SDK_UNAVAILABLE)
